#include "image.h"
#include "treeview.h"
#include "include/dxlibp.h"

#define PI 3.141592653589793
#define DegreeToRadian(degree) ((float)(degree) * PI / 180.0)
#define RadianToDegree(radian) ((float)(radian) * 180.0 / PI)

static float	scale;
static int	x,
			y,
			angle,
			graphhandle;

bool InitImageViewer()
{
	scale = 1.0f;
	angle = 0;
	x = 240;
	y = 136;
	graphhandle = LoadGraph(cursor->FullPath);

	return graphhandle < 0 ? false: true;
}

inline void DrawImageViewer()
{
	DrawRotaGraph(x, y, scale, DegreeToRadian(angle), graphhandle, false, false);
}

inline void ControlImageViewer(int Buttons)
{
	if(Buttons & DXP_INPUT_UP)
	{
		y++;
		if(y > 272)
			y = 272;
	}
	else if(Buttons & DXP_INPUT_DOWN)
	{
		y--;
		if(y < 0)
			y = 0;
	}
	if(Buttons & DXP_INPUT_LEFT)
	{
		x++;
		if(x > 480)
			x = 480;
	}
	else if(Buttons & DXP_INPUT_RIGHT)
	{
		x--;
		if(x < 0)
			x = 0;
	}
	if(Buttons & DXP_INPUT_LTRIGGER)
	{
		if(angle == 0)
			angle = 360;
		angle--;
	}
	if(Buttons & DXP_INPUT_RTRIGGER)
	{
		angle++;
		if(angle == 360)
			angle = 0;
	}
	if(Buttons & DXP_INPUT_TRIANGLE)
	{
		scale += 0.1;
		if(scale > 2.0)
			scale = 2.0;
	}
	if(Buttons & DXP_INPUT_SQUARE)
	{
		scale -= 0.1;
		if(scale < 0.5)
			scale = 0.5;
	}
	if(Buttons & DXP_INPUT_CROSS)
	{
		DeleteGraph(graphhandle);
		Mode = MODE_MAIN;
	}
}