/*
DadrfylibioQlɍDɘM܂B
*/
#include <string.h>

#include "io.h"
#include "memory.h"
#include "progress.h"

void CopyFile(const char *src, const char *dst, bool move)
{
	SceUID fd[2] = {
		sceIoOpen(src, PSP_O_RDONLY, 0777),
		sceIoOpen(dst, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC ,0777)
	};
	void *cpbuf = APImalloc(COPYBUFSIZE);
	while(1)
	{
		int read = sceIoRead(fd[0], cpbuf, COPYBUFSIZE);
		if(read > 0)
			sceIoWrite(fd[1], cpbuf, read);
		pb.Success += read;
		sceKernelDelayThread(1);
		if(read < COPYBUFSIZE)	//obt@TCYǂ񂾃TCŶقȂΑt@C̏I[I
			break;
	}
	APIfree(cpbuf);
	sceIoClose(fd[0]);
	sceIoClose(fd[1]);
	if(move)
		sceIoRemove(src);
}

void CopyDirectory(const char *src, const char *dst, bool move)
{
	SceIoDirent buf;
	memset(&buf, 0, sizeof(SceIoDirent));
	SceUID dfd = sceIoDopen(src);

	sceIoMkdir(dst, 0777);

	while(sceIoDread(dfd, &buf) > 0)
	{
		if(strlen(buf.d_name) && strcmp(buf.d_name, ".") != 0 && strcmp(buf.d_name, "..") != 0)
		{
			char *childsrc = APImalloc(sizeof(char) * (strlen(src) + strlen(buf.d_name) + 2));
			strcpy(childsrc, src);
			strcat(childsrc, "/");
			strcat(childsrc, buf.d_name);
			char *childdst = APImalloc(sizeof(char) * (strlen(dst) + strlen(buf.d_name) + 2));
			strcpy(childdst, dst);
			strcat(childdst, "/");
			strcat(childdst, buf.d_name);
			if(buf.d_stat.st_attr & FIO_SO_IFDIR)
				CopyDirectory(childsrc, childdst, move);
			else
				CopyFile(childsrc, childdst, move);
			APIfree(childsrc);
			APIfree(childdst);
		}
		memset(&buf, 0, sizeof(SceIoDirent));
	}

	sceIoDclose(dfd);
	if(move)
		sceIoRmdir(src);
}

int RemoveDirectory(const char *path)
{
	SceUID dfd = sceIoDopen(path);

	SceIoDirent dir;
	memset(&dir, 0, sizeof(dir));

	while(0 < sceIoDread(dfd, &dir))
	{
		if(strlen(dir.d_name) && strcmp(dir.d_name, ".") != 0 && strcmp(dir.d_name, "..") != 0)
		{
			char *child = APImalloc(sizeof(char) * (strlen(path) + strlen(dir.d_name) + 2));
			strcpy(child, path);
			strcat(child, "/");
			strcat(child, dir.d_name);
			if(dir.d_stat.st_attr & FIO_SO_IFDIR)
				RemoveDirectory(child);
			else
			{
				sceIoRemove(child);
				pb.Success++;
			}
			APIfree(child);

			sceKernelDelayThread(1);
		}
		memset(&dir, 0, sizeof(dir));
	}
	sceIoDclose(dfd);
	
	sceIoRmdir(path);
	pb.Success++;

	return 0;
}

unsigned int GetSize(const char *Name)
{
	SceIoStat stat;
	if(sceIoGetstat(Name, &stat) < 0)
		return 0;
	return stat.st_size;
}

unsigned int GetDirSize(const char *Name)
{
	unsigned int ret = 0;
	SceIoDirent dir;
	memset(&dir, 0, sizeof(SceIoDirent));
	SceUID dfd = sceIoDopen(Name);

	while(sceIoDread(dfd, &dir) > 0)
	{
		if(strlen(dir.d_name) && strcmp(dir.d_name, ".") != 0 && strcmp(dir.d_name, "..") != 0)
		{
			char *child = APImalloc(sizeof(char) * (strlen(Name) + strlen(dir.d_name) + 2));
			strcpy(child, Name);
			strcat(child, "/");
			strcat(child, dir.d_name);
			if(dir.d_stat.st_attr & FIO_SO_IFDIR)
				ret += GetDirSize(child);
			else
				ret += dir.d_stat.st_size;
			APIfree(child);
		}
		memset(&dir, 0, sizeof(SceIoDirent));
	}

	sceIoDclose(dfd);

	return ret;
}

int GetDirCount(const char *Name)
{
	unsigned int ret = 0;
	SceIoDirent dir;
	memset(&dir, 0, sizeof(SceIoDirent));
	SceUID dfd = sceIoDopen(Name);

	while(sceIoDread(dfd, &dir) > 0)
	{
		if(strlen(dir.d_name) && strcmp(dir.d_name, ".") != 0 && strcmp(dir.d_name, "..") != 0)
		{
			char *child = APImalloc(sizeof(char) * (strlen(Name) + strlen(dir.d_name) + 2));
			strcpy(child, Name);
			strcat(child, "/");
			strcat(child, dir.d_name);
			if(dir.d_stat.st_attr & FIO_SO_IFDIR)
				ret += GetDirCount(child);
			else
				ret++;
			APIfree(child);
		}
		memset(&dir, 0, sizeof(SceIoDirent));
	}

	sceIoDclose(dfd);

	return ++ret;
}

bool GetExist(const char *Name)
{
	SceIoStat stat;
	return sceIoGetstat(Name, &stat) < 0 ? false : true;
}
