#ifndef MAIN_H
#define MAIN_H

#include <pspuser.h>
#include <pspsdk.h>
#include <stdbool.h>

#ifdef WIN32
#define __inline__
#undef PSP_LEGACY_TYPES_DEFINED
#define _HAVE_STDC
#endif

enum colors{
	RED = 0xFF0000FF,
	GREEN =	0xFF00FF00,
	BLUE = 0xFFFF0000,
	WHITE =	0xFFFFFFFF,
	LITEGRAY = 0xFFBFBFBF,
	GRAY = 0xFF7F7F7F,
	DARKGRAY = 0xFF3F3F3F,		
	BLACK = 0xFF0F0F0F,
	BROWN = 0xFF404080,
	PINK = 0xFFFF80FF,
	YELLOWGREEN = 0xFF00FF80,
	LIGHTBLUE = 0xFFD8EFA0,
	PURPLE = 0xFFFF0080,
	ORANGE = 0xFF4080FF,
	YELLOW = 0xFF00FFFF,
	SILVER = 0xFFC0C0C0,
	GOLD = 0xFF20C0E6
};

enum Modes{
	MODE_NO,
	MODE_MAIN,
	MODE_PROPERTY,
	MODE_TEXT,
	MODE_IMAGE,
	MODE_SOUND,
	MODE_PROGRESS
};

extern int Mode;

typedef struct{
	char CreateFile[32];
	char CreateFolder[32];
	char Copy[32];
	char Move[32];
	char Paste[32];
	char Remove[32];
	char Rename[32];
	char Property[32];
	char CompressZip[32];
	char TextEditor[32];
	char Playing[32];
}Config;

extern Config cfg;

#endif