#include <pspsysmem.h>

#include "memory.h"

void *APImalloc(SceSize size)
{
	SceUID handle = sceKernelAllocPartitionMemory(PARTITION_ID, "Memory", PSP_SMEM_Low, sizeof(SceUID) + size, NULL);
	if(handle <= 0)
		return NULL;
	void *addr = sceKernelGetBlockHeadAddr(handle);
	*(SceUID *)addr = handle;

	return (addr + sizeof(SceUID));
}

void APIfree(void *ptr)
{
	if(ptr <= (void *)sizeof(SceUID))
		return;
	sceKernelFreePartitionMemory(*(SceUID *)(ptr - sizeof(SceUID)));
}
