#include <psputility.h>
#include <string.h>
#include <pspdisplay.h>
#include <pspgu.h>
#include "main.h"
#include "include/dxlibp.h"
#include "memory.h"

int OnScreenKeybord(char *buf, int buflen, int mode, const char *title, const char *init)
{
	if(!buf)
		return -1;

	u16 *winit, *wtitle, *wresult;
	char nulstr[] = "";
	if(!init)
		init = nulstr;
	if(!title)
		title = nulstr;
	winit = APImalloc((strlen(init) + 1) * 2);
	wtitle = APImalloc((strlen(title) + 1) * 2);
	wresult = APImalloc((buflen + 1) * 2);
	if(!winit || !wtitle || !wresult)
	{
		APIfree(winit);
		APIfree(wtitle);
		APIfree(wresult);
		return -1;
	}

	SJIS_to_UTF16(winit, init);
	SJIS_to_UTF16(wtitle, title);

	SceUtilityOskData data;
	memset(&data, 0, sizeof(SceUtilityOskData));
	sceUtilityGetSystemParamInt(PSP_SYSTEMPARAM_ID_INT_LANGUAGE, &data.language);
	data.unk_00 = 1;	//ATOK
	data.lines = 1;
	data.unk_24 = 1;
	data.inputtype = mode;
	data.desc = wtitle;
	data.intext = winit;
	data.outtextlength = buflen;
	data.outtextlimit = buflen;
	data.outtext = wresult;

	SceUtilityOskParams params;
	memset(&params, 0, sizeof(params));
	params.base.size = sizeof(params);
	sceUtilityGetSystemParamInt(PSP_SYSTEMPARAM_ID_INT_LANGUAGE, &params.base.language);
	sceUtilityGetSystemParamInt(PSP_SYSTEMPARAM_ID_INT_UNKNOWN, &params.base.buttonSwap);
	params.base.graphicsThread = 0x11;
	params.base.accessThread = 0x13;
	params.base.fontThread = 0x12;
	params.base.soundThread = 0x10;
	params.datacount = 1;
	params.data = &data;

	sceUtilityOskInitStart(&params);

	int done = 0;
	while(ProcessMessage() != -1 && !done)
	{
		ClearDrawScreen();
		DrawBox(0, 0, 480, 272, GRAY, true);
		sceGuFinish();
		switch(sceUtilityOskGetStatus())
		{
		case PSP_UTILITY_DIALOG_INIT:
			{
				break;
			}
		case PSP_UTILITY_DIALOG_VISIBLE:
			{
				sceUtilityOskUpdate(1);
				break;
			}
		case PSP_UTILITY_DIALOG_QUIT:
			{
				sceUtilityOskShutdownStart();
				break;
			}
		case PSP_UTILITY_DIALOG_NONE:
		case PSP_UTILITY_DIALOG_FINISHED:
			{
				done = 1;
				break;
			}
		default:
			{
				break;
			}
		}
		sceDisplayWaitVblankStart();
		ScreenFlip();
	}

	UTF16_to_SJIS(buf, wresult);

	APIfree(winit);
	APIfree(wtitle);
	APIfree(wresult);

	switch(data.result)
	{
	case PSP_UTILITY_OSK_RESULT_UNCHANGED:
	case PSP_UTILITY_OSK_RESULT_CANCELLED:
		{
			return 0;
		}
	case PSP_UTILITY_OSK_RESULT_CHANGED:
		{
			return 1;
		}
	}

	return -1;
}
