#include "sound.h"
#include "treeview.h"
#include "include/dxlibp.h"

static int	soundhandle,
			soundlen;

bool InitSoundPlayer()
{
	soundhandle = LoadSoundMem(cursor->FullPath);
	if(soundhandle < 0)
		return false;
	soundlen = GetSoundPlayTime(soundhandle);
	PlaySoundMem(soundhandle, DX_PLAYTYPE_LOOP, 1);

	return true;
}

inline void DrawSoundPlayer()
{
	int soundnow = GetSoundPlayedTime(soundhandle);
	DrawFormatString(0, 0, BLACK, "%s\n\"%s\"", cfg.Playing, cursor->FullPath);
	DrawFormatString(0, 30, BLACK, "%02d:%02d/%02d:%02d", soundnow / 60, soundnow % 60, soundlen / 60, soundlen % 60);
}

inline void ControlSoundPlayer(int Buttons)
{
	if(Buttons & DXP_INPUT_CROSS)
	{
		StopSoundMem(soundhandle);
		DeleteSoundMem(soundhandle);
		Mode = MODE_MAIN;
	}
}