#include <string.h>

#include "include/dxlibp.h"
#include "treeview.h"
#include "util.h"
#include "memory.h"
#include "textviewer.h"
#include "image.h"
#include "sound.h"
#include "file.h"
#include "menu.h"
#include "rco.h"

int	ViewCount,
	TreeCursor,
	TreeScroll;
SceIoDirent_Kai	*head,
				*cursor;

SceIoDirent_Kai *GetDirectory(char *DirName, int *Count)
{
	SceIoDirent buf;
	memset(&buf, 0, sizeof(SceIoDirent));
	SceIoDirent_Kai *head = NULL, *prev = NULL, *ptr = NULL;
	SceUID dfd;
	*Count = 0;

	dfd = sceIoDopen(DirName);

	while(sceIoDread(dfd, &buf) > 0)
	{
		if(strlen(buf.d_name) && strcmp(buf.d_name, ".") != 0 && strcmp(buf.d_name, "..") != 0)
		{
			ptr = APImalloc(sizeof(SceIoDirent_Kai));
			if(!ptr)
				break;

			ptr->FullPath = APImalloc(strlen(DirName) + strlen(buf.d_name) + 2);
			strcpy(ptr->FullPath, DirName);
			strcat(ptr->FullPath, "/");
			strcat(ptr->FullPath, buf.d_name);

			ptr->Name = strrchr(ptr->FullPath, '/') + 1;

			if(buf.d_stat.st_attr & FIO_SO_IFDIR)
				ptr->Ext = FOLDER;
			else
				ptr->Ext = GetExtention(ptr->FullPath);

			ptr->Opened = ptr->Selected = ptr->CopyMark = false;
			ptr->parent = ptr->child = ptr->next = NULL;
			ptr->prev = prev;
			if(!head)
				head = ptr;
			else
				prev->next = ptr;
			prev = ptr;

			(*Count)++;
		}
		memset(&buf, 0, sizeof(SceIoDirent));
	}

	sceIoDclose(dfd);

	return head;
}

static void OneFreeDirectory(SceIoDirent_Kai *ptr)
{
	APIfree(ptr->FullPath);
	APIfree(ptr);
}

void FreeDirectory(SceIoDirent_Kai *head)
{
	SceIoDirent_Kai *p = head;
	while(p){
		if(p->child)
			p = p->child;
		else
		{
			SceIoDirent_Kai *old = p;
			p = p->next;
			if(!p && old->parent)
			{
				while(old->parent->parent && !old->parent->next)
				{
					SceIoDirent_Kai *parent = old->parent;
					OneFreeDirectory(old);
					old = parent;
				}
				p = old->parent->next;
				OneFreeDirectory(old->parent);
			}
			OneFreeDirectory(old);
		}
	}
}

void MakeTree()
{
	if(cursor->child)	//Ɏq΁AV擾͂Ȃ
	{
		cursor->Opened = true;
		ViewCount = GetViewCount();
		return;
	}
	int bufCount = 0;
	SceIoDirent_Kai *buf = GetDirectory(cursor->FullPath, &bufCount);
	if(!bufCount)	//󂾂疳
		return;
	cursor->Opened = true;
	SceIoDirent_Kai *ptr;

	cursor->child = buf;	//VXgɘA
	for(ptr = buf; ptr; ptr = ptr->next)
		ptr->parent = cursor;	//eݒ

	ViewCount = GetViewCount();
}

void CloseTree()
{
	cursor->Opened = false;
	ViewCount = GetViewCount();
	AdjustCursorAndScroll();
}

void AdjustCursorAndScroll()
{
	while(ViewCount - TreeScroll < 12 && ViewCount > 12)
		TreeScroll--;
	if(ViewCount <= 12)
		TreeScroll = 0;
	if(TreeCursor > ViewCount - 1)
		TreeCursor = ViewCount - 1;
}

void AddOneFileToList(SceIoDirent_Kai *newp)
{
	if(cursor->Ext != FOLDER)	//t@CȂA̎ɓ
	{
		newp->next = cursor->next;
		cursor->next = newp;
		newp->prev = cursor;
		if(newp->next)
			newp->next->prev = newp;
		newp->parent = cursor->parent;
		newp->child = NULL;
		ViewCount++;
	}
	else if(cursor->child)	//tH_ŁAɊJĂqɓ
	{
		newp->next = cursor->child;
		cursor->child = newp;
		newp->parent = cursor;
		newp->next->prev = newp;
		newp->prev = newp->child = NULL;
		ViewCount++;
	}
	else	//tH_ŁAJĂȂ̂Ă
		OneFreeDirectory(newp);
}

void RemoveOneFileFromList(SceIoDirent_Kai *old)
{
	if(old->child)	//qΐɎqS
	{
		SceIoDirent_Kai *old2 = old->child;
		while(old2)
		{
			SceIoDirent_Kai *next = old2->next;
			RemoveOneFileFromList(old2);
			old2 = next;
		}
	}
	if(!old->prev)
	{
		if(!old->parent)	//̐擪̏ꍇ
		{
			head = old->next;
			OneFreeDirectory(old);
		}
		else	//q̒Ő擪̏ꍇ
		{
			if(old->next)	//ʂ
			{
				old->parent->child = old->next;
				old->next->prev = NULL;
				OneFreeDirectory(old);
			}
			else	//Ǝq̒ɂȂꍇ
			{
				old->parent->child = NULL;
				old->parent->Opened = false;
				OneFreeDirectory(old);
			}
		}
	}
	else if(!old->next)	//܂͎q̒ōŌ̏ꍇ
	{
		old->prev->next = NULL;
		OneFreeDirectory(old);
	}
	else	//
	{
		old->prev->next = old->next;
		old->next->prev = old->prev;
		OneFreeDirectory(old);
	}
}

void ResetAllSelect()
{
	SceIoDirent_Kai *p = head;
	while(p)
	{
		p->Selected = false;
		if(p->child)
			p = p->child;
		else
		{
			SceIoDirent_Kai *p2 = p;
			p = p->next;
			if(!p && p2->parent)
			{
				SceIoDirent_Kai *p3 = p2;
				while(p3->parent->parent && !p3->parent->next)
					p3 = p3->parent;
				p = p3->parent->next;
			}
		}
	}
}

int GetViewCount()
{
	int i;
	SceIoDirent_Kai *p = head;
	for(i = 0; p; i++)
	{
		if(p->Opened && p->child)
			p = p->child;
		else
		{
			SceIoDirent_Kai *p2 = p;
			p = p->next;
			if(!p && p2->parent)
			{
				while(p2->parent->parent && !p2->parent->next)
					p2 = p2->parent;
				p = p2->parent->next;
			}
		}
	}

	return i;
}

inline void DrawTreeView()
{
	int i;
	unsigned int depth = 0;
	SceIoDirent_Kai *ptr = head;
	for(i = 0; i < TreeScroll; i++)
	{
		if(ptr->Opened && ptr->child)
		{
			ptr = ptr->child;
			depth++;
		}
		else
		{
			SceIoDirent_Kai *ptr2 = ptr;
			ptr = ptr->next;
			if(!ptr && ptr2->parent)
			{
				SceIoDirent_Kai *ptr3 = ptr2;
				while(ptr3->parent->parent && !ptr3->parent->next)
				{
					ptr3 = ptr3->parent;
					depth--;
				}
				ptr = ptr3->parent->next;
				depth--;
			}
		}
	}
	for(i = 0; i < ViewCount && i < 12 && ptr; i++)
	{
		if(i + TreeScroll == TreeCursor)
		{
			DrawGraph(0, i * 22 + 4, Select[0], false);
			cursor = ptr;
		}
		if(ptr->Selected)
			DrawGraph(0, i * 22 + 4, Select[1], false);

		if(ptr->Ext == FOLDER)
			DrawGraph(depth * 20 + 7, i * 22 + 7, Extention[0], true);
		else
		{
			switch(ptr->Ext)
			{
			case TEXTFILE:
				{
					DrawGraph(depth * 20 + 7, i * 22 + 7, Extention[2], true);
					break;
				}
			case MUSICFILE:
				{
					DrawGraph(depth * 20 + 7, i * 22 + 7, Extention[3], true);
					break;
				}
			case ARCHIVEFILE:
				{
					DrawGraph(depth * 20 + 7, i * 22 + 7, Extention[4], true);
					break;
				}
			case PICTUREFILE:
				{
					DrawGraph(depth * 20 + 6, i * 22 + 8, Extention[5], true);
					break;
				}
			default:
				{
					DrawGraph(depth * 20 + 7, i * 22 + 7, Extention[1], true);
					break;
				}
			}
		}

		DrawString(depth * 20 + 25, i * 22 + 8, ptr->Name, BLACK, 0);
		if(ptr->Opened && ptr->child)
		{
			ptr = ptr->child;
			depth++;
		}
		else
		{
			SceIoDirent_Kai *ptr2 = ptr;
			ptr = ptr->next;
			if(!ptr && ptr2->parent)
			{
				SceIoDirent_Kai *ptr3 = ptr2;
				while(ptr3->parent->parent && !ptr3->parent->next)
				{
					ptr3 = ptr3->parent;
					depth--;
				}
				ptr = ptr3->parent->next;
				depth--;
			}
		}
	}					

	DrawGraph(464, 0, ScrollBar[1], false);
	double ScrollOneStep = 272.0 / (double)ViewCount * 236.0 / 272.0;	//(Ŝ̒) / (ڐ) * (o[\͈͂̒) / (Ŝ̒) ۂ
	if(ViewCount > 12)
	{
		DrawRectGraph(464, 18 + ScrollOneStep * TreeScroll, 0, 0, 15, 3, ScrollBar[0], false, false);
		DrawRectGraph(464, 21 + ScrollOneStep * TreeScroll, 0, 3, 15, ScrollOneStep * 12 - 3, ScrollBar[0], false, false);
		DrawRectGraph(464, 15 + ScrollOneStep * TreeScroll + ScrollOneStep * 12, 0, 269, 15, 3, ScrollBar[0], false, false);
	}
}

inline void ControlTreeView(int Buttons)
{
	if(Buttons & DXP_INPUT_UP)
	{
		TreeCursor--;
		if(TreeCursor < 0)
		{
			TreeCursor = ViewCount - 1;
			if(ViewCount > 12)
				TreeScroll = ViewCount - 12;
		}
		else if(TreeCursor + 1 == TreeScroll)
			TreeScroll--;
	}
	else if(Buttons & DXP_INPUT_DOWN)
	{
		TreeCursor++;
		if(TreeCursor > ViewCount - 1)
			TreeCursor = TreeScroll = 0;
		else if(TreeCursor - TreeScroll >= 12)
			TreeScroll++;
	}
	else
	{
		if(Buttons & DXP_INPUT_CIRCLE)
		{
			if(cursor->Ext == FOLDER)
			{
				if(!cursor->Opened)
					MakeTree();
				else
					CloseTree();
			}
			else
			{
				switch(cursor->Ext)
				{
				case TEXTFILE:
					{
						ReadFile(cursor->FullPath);
						Mode = MODE_TEXT;
						break;
					}
				case MUSICFILE:
					{
						if(InitSoundPlayer())
							Mode = MODE_SOUND;

						break;
					}
				case ARCHIVEFILE:
					{
						//if(!strcasecmp(".zip", strrchr(cursor->FullPath, '.')))
							ExtractZip();
						//else
							//ExtractRar();
						Mode = MODE_PROGRESS;
						break;
					}
				case PICTUREFILE:
					{
						if(InitImageViewer())
							Mode = MODE_IMAGE;
						break;
					}
				default:
					{
						break;
					}
				}
			}
		}
		if(Buttons & DXP_INPUT_SQUARE)
			cursor->Selected ^= true;
		if(Buttons & DXP_INPUT_TRIANGLE)
		{
			cursor->Selected = true;
			MenuOpen = true;
		}
	}
}
