#include <string.h>

#include "util.h"

#define GetArrayLength(array) (sizeof(array) / sizeof(array[0]))

static char *PicExt[] = {
	"bmp",	//bmp
	"png",	//png
	"jpeg",	//jpg
	"jpg",
	"jpe",
	"jfif",
	"jfi",
	"jif"
};
static char *MusicExt[] = {
	"mp3",	//mp3
	"at3",	//at3
	"wav"	//wav
};
static char *TextExt[] = {
	"txt",	//txt
	"ini",	//ini
	"cfg",	//cfg
	"c",	//C
	"cpp",	//C++
	"cxx",
	"cc",
	"cs",	//C#
	"s",	//ASM
	"php",	//PHP
	"js",	//JavaScript
	"java", //Java
	"py",	//Python
	"html",	//HTML
	"css",	//CSS
};

Extentions GetExtention(const char *FullPath)
{
	int i;
	char *p;
	bool NoExtention = true;
	for(p = strrchr(FullPath, '/'); *p; p++)
	{
		if(*p == '.')
			NoExtention = false;
	}
	if(NoExtention)	//gqȂt@C΍
		return UNKFILE;

	char *ext = strrchr(FullPath, '.') + 1;
	if(!*ext)
		return UNKFILE;

	for(i = 0; i < GetArrayLength(PicExt); i++)
	{
		if(!strcasecmp(ext, PicExt[i]))
			return PICTUREFILE;
	}
	for(i = 0; i < GetArrayLength(MusicExt); i++)
	{
		if(!strcasecmp(ext, MusicExt[i]))
			return MUSICFILE;
	}
	for(i = 0; i < GetArrayLength(TextExt); i++)
	{
		if(!strcasecmp(ext, TextExt[i]))
			return TEXTFILE;
	}
	if(!strcasecmp(ext, "zip")/* || !strcasecmp(ext, "rar")*/)
		return ARCHIVEFILE;

	return UNKFILE;
}

void GetDevice(const char *argv0, char *buf)
{
	while(*argv0)
	{
		*buf++ = *argv0++;
		if(*(argv0 - 1) == ':')
			break;
	}
	*buf = '\0';
}

void DeleteMarkFromFileName(char *str)
{
	int i, j;
	for(i = 0; str[i] != '\0'; i++)
	{
		if(str[i] == '\\' || str[i] == '/' || str[i] == ':' || str[i] == '*' || str[i] == '?' || str[i] == '\"' || str[i] == '<' || str[i] == '>' || str[i] == '|')
		{
			for(j = i; str[j] != '\0'; j++)
				str[j] = str[j + 1];
			i--;
		}
	}
}
